/*	Java Phoenix Emulator v0.30
Official Home-page: http://www.dcc.ufmg.br/~muriloq/phoenix

  Emulator by Murilo Saraiva de Queiroz (muriloq@dcc.ufmg.br) based on 
  Phoenix Emulator by Richard Davies (R.Davies@dcs.hull.ac.uk) and MAME 
  project, by Nicola Salmoria (MC6489@mclink.it) and others.
  
	The emulator structure, and many solutions are based in Jasper, the 
	Java Spectrum Emulator, by Adam Davidson & Andrew Pollard.
	Used with permission.
	
	  The machine architecture information is from Ralph Kimmlingen
	  (ub2f@rz.uni-karlsruhe.de).
	  
*/


import java.awt.*;
import java.util.*;
import java.io.*;
import java.net.*;
import java.applet.*;
import java.net.URL;
import JPhoenixFrame;

public class JPhoenix extends Applet implements Runnable{
	Phoenix phoenix = null;
	Thread	thread	= null;
	URL		baseURL = null;
	
	public static void main(String args[])
	{
		
       	JPhoenixFrame frame = new JPhoenixFrame("JPhoenix");
		frame.show();
		frame.hide();
		frame.resize(frame.insets().left + frame.insets().right  + 208,
			frame.insets().top  + frame.insets().bottom + 256);
		JPhoenix applet_JPhoenix = new JPhoenix();
		frame.add("Center", applet_JPhoenix);
		applet_JPhoenix.init();
		applet_JPhoenix.start();
		frame.show();
	}
	
	
	public void init() {
		try {
			baseURL = getDocumentBase();
		}
		catch (Exception e) {
			baseURL = null;
		}
		
	}
	
	public void start() {
		if ( thread == null ) {
			thread = new Thread( this, "JPhoenix" );
			thread.start();
		}
	}
	
	
	public void stop() {
		if ( thread != null ) {
			thread.stop();
			thread = null;
		}
	}
	
	/** Event handling. */
	public boolean handleEvent( Event e ) {
		if ( phoenix != null ) {
			return phoenix.handleEvent( e );
		}
		return super.handleEvent( e );
	}
	
	/** Refresh handling. */
	/*
	public void update( Graphics g ) {
	paint( g );
	}
	*/
	
	/** Paint sets a flag on the spectrum to tell it to redraw the
	screen on the next 8080 interrupt. */
	/*
	public void paint( Graphics g ) {
	if ( phoenix != null ) {
	phoenix.repaint();
	}
	}
	*/
	
	/** Read applet parameters and start the emulation. */
	public void run() {
		if ( phoenix == null ) {
			try {
				phoenix = new Phoenix( this );
				phoenix.loadRom (baseURL);
				phoenix.loadChr (baseURL);
				phoenix.initSFX(this);
				phoenix.decodeChars ();
				phoenix.hiload();
				
			}
			catch ( Exception e ) {
			}
		}
		
		if ( phoenix != null ) {
			phoenix.execute();
		}
	}
}
